# Copyright (c) KylinSoft Co., Ltd. [2024].All rights reserved. 

function run_audit_command() {
	export PRS7000TERM_REC_STATUS=run;

	myFile="/usr/local/csma/KylinCmdEchoMonitor"
	if [ -f "$myFile" ]; then
		exec /usr/local/csma/KylinCmdEchoMonitor
	else
		export PRS7000TERM_REC_FILE=false;
	fi
}

function send_audit_info() {
	if [ -z "${PRS7000AUDIT_SEND_HIS_CMD_LAST}" -o "${PRS7000AUDIT_SEND_HIS_CMD_LAST}" != "$(history 1;)" ];
	then 
		export PRS7000AUDIT_SEND_HIS_CMD_LAST=$(history 1;);
		sessionid=$(loginctl session-status | awk 'NR==1 {print $1}')
		{ lastcmd=$(history 1 | { read x y; echo $y; }); printf "EB09EB90<*>|<*>$sessionid<*>|<*>$(whoami)<*>|<*>$$<*>|<*>$PWD<*>|<*>$lastcmd<*>|<*>$(tty)<*>|<*>EB09EB90"; } | nc -u -4 --send-only 127.0.0.1 6751;
	fi;

}

function do_run() {
	if [ -z "${PRS7000TERM_REC_STATUS}" -o "${PRS7000TERM_REC_STATUS}" != "run" ];
	then 
		run_audit_command
	else 
		export PROMPT_COMMAND="";
		export HISTCONTROL="";
		readonly PROMPT_COMMAND;
		readonly HISTCONTROL;
		trap send_audit_info DEBUG;
	fi;
}

export PROMPT_COMMAND=do_run

