# Copyright (c) KylinSoft Co., Ltd. [2024].All rights reserved. 


osType=0
getOsType(){
	osType=1
	echo $osType
}
osType=`getOsType`
passLockFileCheck(){
	result=''
	if [ $osType = 1 ];then
		passLockFile='/etc/pam.d/system-auth'
	elif [ $osType = 2 ];then
		passLockFile='/etc/pam.d/passwd'
		[ -f $passLockFile ] || passLockFile='/etc/pam.d/common-password'
	else:
		pass
	fi
	
	if [ -f "$passLockFile" ] ;then

		denyStr="`cat /etc/pam.d/system-auth|egrep "^auth\s*required\s*pam_tally.so"  | grep -o 'deny=[0-9]*'`"
		if [ -z "$denyStr" ];then
			echo -2,"未设置该项内容"
		else
			denyNums=`echo $denyStr |sed -e 's/deny=//'`
			if [ $denyNums = 5 ];then
				echo 1,"口令锁定次数:"$denyNums
			else	
				echo 0,"口令锁定次数:"$denyNums
			fi
		fi
	else
		echo -1,'文件不存在'
	fi
}
fileSuidSgidCheck(){
	FILE=`find / -type f -perm +6000 -exec ls -l {} \; 2>/dev/null`
	if [ -n "$FILE" ]
	then
			echo 0,"存在未授权的SUID-SGID文件\n"$FILE
	else
			echo 1,"不存在未授权的SUID-SGID文件"
	fi
}
uidUserInfoCheck(){
	userInfo="`awk -F: '($3 == 0) { print $1}' /etc/passwd | grep -v root`"
	[ -z "$userInfo" ] && echo 1,"UID=0用户只有root" || echo 0,"UID-0用户有$userInfo"
}
passStrategyInfoCheck(){
	if [ -f "/etc/security/pwquality.conf" ];then
		minlen=$(grep -E '^\s*minlen\s*=' /etc/security/pwquality.conf | awk -F '=' '{print$2}' |awk '{print $1}')
		dcredit=$(grep -E '^\s*dcredit\s*=' /etc/security/pwquality.conf | awk -F '=' '{print$2}' |awk '{print $1}')
		lcredit=$(grep -E '^\s*lcredit\s*=' /etc/security/pwquality.conf | awk -F '=' '{print$2}' |awk '{print $1}')
		ucredit=$(grep -E '^\s*ucredit\s*=' /etc/security/pwquality.conf | awk -F '=' '{print$2}' |awk '{print $1}')
		ocredit=$(grep -E '^\s*ocredit\s*=' /etc/security/pwquality.conf | awk -F '=' '{print$2}' |awk '{print $1}')
		minclass=$(grep -E '^\s*minclass\s*=' /etc/security/pwquality.conf | awk -F '=' '{print$2}' |awk '{print $1}')

		if [ "$minlen" = "8" ] && [[ "$dcredit" = "-1" ]] && [[ "$lcredit" = "-1" ]] && [[ "$ucredit" = "-1" ]] && [[ "$ocredit" = "-1" ]] & [ "$minclass" = "3" ]
		then
			echo 1,"口令策略:minlen=8,dcredit=-1,lcredit=-1,ucredit=-1,ocredit=-1,minclass=3"
		else
			echo 0,"未进行正确设置密码策略"
		fi

		unset minlen
		unset ucredit
		unset lcredit
		unset dcredit
		unset ocredit
		unset minclass
	else
		echo no
	fi
}
# passStrategyInfoCheck(){
# 	passFile=''
#     [  $osType = 1 ] && passFile="/etc/pam.d/system-auth"
#     if [  $osType = 2 ] ;then
#          passFile="/etc/pam.d/common-password"
#          [ -e "/etc/pam.d/passwd" ]  && passFile="/etc/pam.d/passwd"
#     fi

#     info="`cat $passFile |grep  '^\s*password\s*required.*.so'`"
#     [ -z "$info" ] && echo 0,"未启用正确的口令策略" && return
#     par1="disabled,disabled,disabled,8,8 max=40 retry=3"
#     par2="try_first_pass retry=3 dcredit=-1 lcredit=-1 ucredit=-1 ocredit=-1 minlen=8"
#     charge(){
#         src=$1
#         dst=$2
#         for p in `echo $src`
#         do
#             [ -z "`echo \"$info\" |grep \"$p\"`" ] && echo 0 && return
#         done
#         echo 1
#     }
#     par1C="`charge "$par1" "$info"`"
#     par2C="`charge "$par2" "$info"`"
#     [ "$par1C" = 1 ] && echo 1,"口令策略:$info" && return
#     [ "$par2C" = 1 ] && echo 1,"口令策略:$info" && return
#     echo 0,"未进行正确设置密码策略,$info"
# }
rootPathSecurityInfoCheck(){
	info="`echo $PATH |egrep '\./|\.\./'`"
	[ -z "$info" ] && echo 1,'root PATH ok' || echo 0,"PATH不正确,$PATH"
}
remoteLogAccordInfoCheck(){
	logFile=''
	[ -e '/etc/rsyslog.conf' ] && logFile="/etc/rsyslog.conf"
	[ -e '/etc/syslog.conf' ] && logFile="/etc/syslog.conf"

	if [ -n "$logFile" ]; then
		num=$(netstat -lnptu | grep rsyslog | wc -l)
		[ $num -gt 0 ] && echo 1,"远程日志记录开启,",$info || echo 0,"远程日志记录未开启,$info"
	fi
}
sshBannerInfoCheck(){
	sshd=`ps auxf|grep 'bin/sshd' |grep -v grep`
	[ -z "$sshd" ] && echo 0,"ssh服务未开启" && return 
	bannerFile="/etc/motd"
	[ -s $bannerFile ] && echo 1,"ssh Banner:`cat $bannerFile`" || echo 0,"ssh banner 为空"
}
unuselessUserInfoCheck(){
	unUser='lp|sync|halt|news|uucp|operator|games|gopher|smmsp|nfsnobody|nobody'
	unPass='\*|\!\!'
	unShell='/bin/false'
	flag=0
	msg="INFO:"
	user=`cat /etc/passwd |egrep "$unUser"`
	[ -z "$user" ] && echo 1,"无lp|sync|halt|news|uucp|operator|games|gopher|smmsp|nfsnobody|nobody用户存在" && return
	
	# userShell="`cat /etc/passwd|egrep \"$unUser\" | awk '{ split($0,a,\":\"); print a[1],a[7]}' | grep  -v '/bin/false'`"
	userPass="`cat /etc/shadow|egrep -w \"$unUser\" | awk '{ split($0,a,\":\"); print a[1],a[2]}' | egrep -v '\*|\!\!'`"
	
	# [ -n "$userShell" ] && msg=$msg" shell不正确,$userShell;" 
	[ -n "$userPass" ] && msg=$msg" passwd不正确,$userPass"
	
	[ "$msg" = "INFO:" ] && flag=1 && msg=$msg"没有无关用户" 	
	echo $flag,$msg
}
userAuthMinInfoCheck(){
	flag=0
	msg=""
	passwd="`stat  /etc/passwd | grep 'Access: (' | awk '{print $2}'| cut -d '/' -f1 | sed -e 's/(//'`"
	shadow="`stat  /etc/shadow | grep 'Access: (' | awk '{print $2}'| cut -d '/' -f1 | sed -e 's/(//'`"
	egroup="`stat  /etc/group | grep 'Access: (' | awk '{print $2}'| cut -d '/' -f1 | sed -e 's/(//'`"
	sevice="`stat  /etc/services | grep 'Access: (' | awk '{print $2}'| cut -d '/' -f1 | sed -e 's/(//'`"
	securi="`stat  /etc/security | grep 'Access: (' | awk '{print $2}'| cut -d '/' -f1 | sed -e 's/(//'`"


	passwdD="0644"
        shadowD="0400"
        egroupD="0644"
        seviceD="0644"
        securiD="0600"
        inetcfD="0600"
	
	check(){
		a=$1
		a1=`echo ${a:0:1}`;a2=`echo ${a:1:1}`;a3=`echo ${a:2:1}`;a4=`echo ${a:3:1}`;
		b=$2
		b1=`echo ${b:0:1}`;b2=`echo ${b:1:1}`;b3=`echo ${b:2:1}`;b4=`echo ${b:3:1}`;
		
		[ $a1 -le $b1 ] && [ $a2 -le $b2 ] && [ $a3 -le $b3 ] && [ $a4 -le $b4 ] && echo 1 || echo 0
		
	}
	
	[ `check $passwd $passwdD` = 1 ] ||  msg=$msg"passwd:$passwd;"  
	[ `check $shadow $shadowD` = 1 ] ||  msg=$msg"shadow:$shadow;"  
	[ `check $egroup $egroupD` = 1 ] ||  msg=$msg"egroup:$egroup;"  
	[ `check $sevice $seviceD` = 1 ] ||  msg=$msg"services:$sevice;"
	[ `check $securi $securiD` = 1 ] ||  msg=$msg"security:$securi;"

	if [ -e '/etc/inetd.conf' ];then
	 	inetcf="`stat  /etc/inetd.conf | grep 'Access: (' | awk '{print $2}'| cut -d '/' -f1 | sed -e 's/(//'`"
		[ `check $inetcf $inetcfD` = 1 ] ||  msg=$msg"inetd.conf:$inetcf;"
	fi

	[ "$msg" = 'INFO:' ] && flag=1 && msg="All Auth ok"
	echo $flag,$msg
}
securityEventLogAccordInfoCheck(){	
	# checkFile=""
	# [ -e '/etc/rsyslog.conf' ] && checkFile="/etc/rsyslog.conf"
	# [ -e '/etc/syslog.conf' ] && checkFile="/etc/syslog.conf"
	
	# info=`cat $checkFile |grep "^\*\.err;kern.debug;daemon.notice\s*/var/adm/messages"`
	# [ -n "$info" ] && echo 1,"安全事件日志记录设置正确" || echo 0,"安全事件日志记录设置错误"
	flag=0
	if [ -s /etc/syslog.conf ]
	then
		oldIFS=$IFS
		IFS=$'\n'
		for line in $(cat /etc/syslog.conf)
		do
			if [ `echo $line | grep -v ^[[:space:]]*# | grep '/^[[:space:]]*\*\.err\;kern\.debug\;daemon\.notice[[:space:]]*\/var\/adm\/messages[[:space:]]*/{print $0}'` ]
			then
				flag=1
			fi
		done

		IFS=$oldIFS
	elif [ -s /etc/rsyslog.conf ]
	then
		oldIFS=$IFS
		IFS=$'\n'

		logfile="/etc/rsyslog.conf"  # rsyslog.conf文件路径
		keyword="authpriv\.\*"  # 关键词，用于匹配安全日志规则

		# 检查是否存在包含关键词的行且没有被注释掉
		grep_result=$(grep -E "^[[:space:]]*[^#]*$keyword" "$logfile")
		
		if [[ -n "$grep_result" ]]; then
			flag=1
		else
			flag=0
		fi

		IFS=$oldIFS
	fi

	if [ $flag -eq 0 ]
	then
		echo 0,"安全事件日志记录设置错误"
	elif [ $flag -eq 1 ]
	then
		echo 1,"安全事件日志记录设置正确"
	fi

	unset flag oldIFS line
}
userGroupMaxMinInfoCheck(){
    UP_GIDMIN=`(grep -v "^#" /etc/login.defs |grep "^GID_MIN"|awk '($1="GID_MIN") {print $2}')`
    UP_GIDMAX=`(grep -v "^#" /etc/login.defs |grep "^GID_MAX"|awk '($1="GID_MAX") {print $2}')`
    info=`egrep -v "oracle|sybase|postgres" /etc/passwd|awk -F: '($4>='$UP_GIDMIN' && $4<='$UP_GIDMAX') {print $1":"$3":"$4}'
`
    [ -n "$info" ] && echo 1,"存在合规用户组$info" || echo 0,"不存在合规用户组"
}
ipRouteForwardForbidenInfoCheck(){
	info=`sysctl -n net.ipv4.ip_forward`
	[ "$info" = "0" ] && echo 1,"禁止IP路由转发正确" || echo 0,"禁止IP路由转发设置错误"
}
nfsServiceLimitCheck(){
	service=`ps -ef | grep nfs | grep -v grep`
	NFS_allow=0
	NFS_deny=0
	if test $service
	then
			NFS=1
			if [ -s /etc/hosts.allow ]
			then
					while read line
					do
							if [ `echo $line | grep -v '^[[:space:]]*#'` ]
							then
							item=`echo $line | awk -F ':' '{print $1}'`
							if [ `echo $item | grep -i all` ]||[ `echo $item | grep -i nfs` ]
							then
									NFS_allow=1
							fi
							fi
					done < '/etc/hosts.allow'
			else
					NFS_allow=0
			fi

			if [ -s /etc/hosts.deny ]
			then
					while read line 
					do
					if [ `echo $line | grep -v '^[[:space:]]*#'` ]
					then
						item=`echo $line | awk -F ':' '{print $1}'`
						if [ `echo $item | grep -i all` ]||[ `echo $item | grep -i nfs` ]
						then
							NFS_deny=1
						fi
					fi
					done < '/etc/hosts.deny'
			else
					NFS_deny=0
			fi
	else
			NFS=0
	fi

	#echo NFS=$NFS
	if [ $NFS -eq 0 ]
	then
			echo 1,"NFS守护进程未启动"  
	else
			if [ $NFS_allow -eq 1 ]
			then
					echo 1,"已设置允许远程访问NFS的IP地址"
			else
					if [ $NFS_deny -eq 1 ]
					then
							echo 1,"已设置禁止远程访问NFS的IP地址"
					else
							echo 0,"NFS服务开启且未设置访问黑白名单"
					fi
			fi
	fi

}

crtlAltDeleteForbidenInfoCheck(){
	info=`cat /etc/inittab |grep '^ca.*ctrlaltdel:/sbin/shutdown.*now'`
	[ -n "$info" ] && echo 0,"Ctrl+Alt+Delete未禁止" || echo 1,"Ctrl+Alt+Delete禁止"
}
controlRemoteAccessIPInfoCheck(){
	allow=`cat /etc/hosts.allow |grep -v "^#" |grep -v "^\s*$" | grep sshd`
	denys=`cat /etc/hosts.deny |grep -v "^#" |grep -v "^\s*$" | grep sshd:all:deny`
	
	[ -n "$allow" ] && [ -n "$denys" ] && echo 1,"远程IP访问已正确配置" && return
	echo 0,"远程IP访问未配置"
}
nullPasswdInfoCheck(){
	info=`awk -F: '( $2 == "" ) { print $1 }' /etc/shadow`
	[ -n "$info" ] && echo 0,"存在空密码用户,$info" || echo 1,"无空密码用户"	
}
ntpServerConfigInfoCheck(){
	ntpServer=`ps -ef |egrep 'ntp|ntpd' |grep -v grep`
	if [ -z "$ntpServer" ] ;
	then
		[ -x /etc/init.d/ntpd ] && /etc/init.d/ntpd start >/dev/null 2&>1
		[ -x /etc/init.d/ntp ] && /etc/init.d/ntp start >/dev/null 2&>1
	fi
	ntpServer=`ps -ef |egrep 'ntp|ntpd' |grep -v grep`
	[ -z "$ntpServer" ] && echo 0,"NTP启动失败" && return
	
	confFile=""
	[ -e /etc/ntp.conf ] && confFile="/etc/ntp.conf"
	[ -e /etc/ntp.conf ] && confFile="/etc/ntp.conf"
	[ -e /etc/ntp/ntp.conf ] && confFile="/etc/ntp/ntp.conf"
	
	conf=`cat $confFile |grep '^server\s*'`
	[ -n "$conf" ] && echo 1,"NTP 启动，配置ok,$conf" || echo 0,'NTP启动，未配置服务器'
}
icmpRedirectForbidenInfoCheck(){
	info=`sysctl -n net.ipv4.conf.all.accept_redirects`
	[ "$info" = "0" ] && echo 1,"禁止ICMP重定向正确" || echo 0,"禁止ICMP重定向错误"
}
snmpCommunityInfoCheck(){
		snmp=`chkconfig --list |grep snmp |egrep 'on|开启'`
		snmpd=`ps auxf|grep 'bin/snmpd ' | grep -v grep`
		[ -z "$snmp" ] && [ -z "$snmpd" ] && echo 1,"SNMP未启用" && return
		conf=''
		[ -e "/etc/snmp.conf" ] && conf="/etc/snmpd.conf"
		[ -e "/etc/snmp/snmpd.conf" ] && conf="/etc/snmp/snmpd.conf"
		info=`cat $conf |grep -v '^#' |grep -v '^\s*$' |grep public`
		[ -n "$info" ] && echo 0,"snmp 启动，且用默认public密码,$info" && return
		echo 1,"SNMP启用，且修改默认Public"
}
screenLockCheck(){
	type gconftool-2 >/dev/null 2>&1 || { echo no ;exit 1; }
	idle_delay=`gconftool-2 -R / | grep '/^[[:space:]]*idle_delay[[:space:]]*=[[:space:]]*[0-9]*[[:space:]]*$'`
	count=`gconftool-2 -R / | grep '/^[[:space:]]*idle_delay[[:space:]]*=[[:space:]]*[0-9]*[[:space:]]*$' | wc -l`
	count_1=0
	for element in $idle_delay
	do
		if [ "$element" -gt 0 ] 2>/dev/null ;then
	       #if grep '^[[:digit:]]*$' <<< "$element";then
	                if [[ $element -le 15 ]];then
	                        let "count_1+=1"
	                fi
	        fi
	done
	
	if [[ $count_1 -eq $count ]];then
	        echo 1,"空闲激活时间合规"
	else
	        echo 0,"空闲激活时间不合规"
	fi

	
	#if [[ $idle_delay -le 15 ]]
	#then
	#	echo yes
	#else
	#	echo no
	#fi
}

# screenLockCheck(){
# 	idle_activation=`gconftool-2 -R / 2>/dev/null | grep '^\s*idle_activation_enabled\s*=\s*true' |awk '{print $3}'`
# 	if [ "$idle_activation" = true ]
# 	then
# 					idle_activation_flag=1
# 					#echo 1,"启用空闲激活"
# 	else
# 					idle_activation_flag=0
# 					#echo 0,"未启用空闲激活"
# 	fi
# 	lock_enabled=`gconftool-2 -R / 2>/dev/null| grep '^\s*lock_enabled\s*=\s*true' |awk '{print $3}'`
# 	if [ "$lock_enabled" = true ]
# 	then
# 					lock_enabled_flag=1
# 					#echo 1,"启用屏幕锁定"
# 	else
# 					lock_enabled_flag=0
# 					#echo 0,"未启用屏幕锁定"
# 	fi
# 	screen_mode=`gconftool-2 -R / 2>/dev/null| grep '^\s*mode\s*=\s*blank-only' |awk '{print $3}'`
# 	if [ "$screen_mode" = blank-only ]
# 	then
# 					screen_mode_flag=1
# 					#echo 1,"启用屏保模式"
# 	else
# 					screen_mode_flag=0
# 					#echo 0,"未启用屏保模式"
# 	fi
# 	idle_delay=`gconftool-2 -R / 2>/dev/null| gawk '/^[[:space:]]*idle_delay[[:space:]]*=[[:space:]]*[0-9]*[[:space:]]*$/{print $0}'`
# 	if [[ "$idle_delay" -le 15 ]]
# 	then
# 					idle_delay_flag=1
# 					#echo 1,"空闲激活时间合规"
# 	else
# 					idle_delay_flag=0
# 					#echo 0,"空闲激活时间过长("$idle_delay")"
# 	fi
# 	if [ $idle_activation_flag -eq 1 ] && [ $lock_enabled_flag -eq 1 ] && [ $screen_mode_flag -eq 1 ] && [ $idle_delay_flag -eq 1 ]
# 	then
# 			echo 1,"屏幕锁定设置合规"
# 	else
# 			msg=""
# 			if [ $idle_activation_flag -eq 0 ]
# 			then
# 					msg=$msg",未启用空闲激活"
# 			fi
# 			if [ $lock_enabled_flag -eq 0 ]
# 			then
# 					msg=$msg",未启用屏幕锁定"
# 			fi
# 			if [ $screen_mode_flag -eq 0 ]
# 			then
# 					msg=$msg",未启用屏保模式"
# 			fi
# 			if [ $idle_delay_flag -eq 0 ]
# 			then
# 					msg=$msg",空闲激活时间过长("$idle_delay"秒)"
# 			fi
# 			echo 0$msg
# 	fi

# }

userLoginLogAccordInfoCheck(){	
	if [ -s /etc/syslog.conf ]
	then
        log=`cat /etc/syslog.conf | grep -v "^[[:space:]]*#" | grep '/^([[:space:]]*authpriv\.\*[[:space:]]*|[[:space:]]*authpriv\.info.*[[:space:]]*|[[:space:]]*\*\.\*[[:space:]]*)'`
	fi

	if [ -s /etc/rsyslog.conf ]
	then
        log=`cat /etc/rsyslog.conf | grep -v "^[[:space:]]*#" | grep -E '^([[:space:]]*authpriv\.\*[[:space:]]*|[[:space:]]*authpriv\.info.*[[:space:]]*|[[:space:]]*\*\.\*[[:space:]]*)'`
	fi
	if [[ -n "$log" ]]
	then
			echo 1,"用户登录日志记录设置正确"
	else
			echo 0,"用户登录日志记录设置错误"
	fi
}
syslogAuthInfoCheck(){
	logFile=''
	[ -f "/etc/syslog.conf" ] && logFile="/etc/syslog.conf"
	[ -f "/etc/rsyslog.conf" ] && logFile="/etc/rsyslog.conf"
	logFiles=`cat $logFile| grep -v "^\s*#"|grep -v '^\s*$'| awk '{print $2}' | sed 's/^-//g'|grep '^\s*\/'`
	passwdD="0640"
	check(){
		a=$1
		a1=`echo ${a:0:1}`;a2=`echo ${a:1:1}`;a3=`echo ${a:2:1}`;a4=`echo ${a:3:1}`;
		b=$2
		b1=`echo ${b:0:1}`;b2=`echo ${b:1:1}`;b3=`echo ${b:2:1}`;b4=`echo ${b:3:1}`;
		
		[ $a1 -le $b1 ] && [ $a2 -le $b2 ] && [ $a3 -le $b3 ] && [ $a4 -le $b4 ] && echo 1 || echo 0
		
	}
	for f in `echo "$logFiles"`
	do
		
		passwd="`stat  $f | grep 'Access: (' | awk '{print $2}'| cut -d '/' -f1 | sed -e 's/(//'`"	
		flag=`check $passwd $passwdD`
		[ $flag = 0 ] && echo 0,"存在日志权限不合规$f:$passwd" && return
		 
	done
	echo 1,"日志权限均正确"
}

loginTMOUTCheck(){
	TMOUTInfo="`cat /etc/profile|egrep '^\s*TMOUT'`"
	if [ -z $TMOUTInfo ];then
		echo 0,"未设置登录超时TMOUT选项"
	else
		TMOUT=`echo $TMOUTInfo |sed -e 's/TMOUT=//' | grep -o '[0-9]*'`
		if [ $TMOUT = 300 ] ;then
			echo 1,"TMOUT值为:$TMOUT"
		else
			echo 0,"TMOUT职位:$TMOUT"
		fi
	fi
}
sysSULogAccordInfoCheck(){	
	checkFile=""
	[ -e '/etc/rsyslog.conf' ] && checkFile="/etc/rsyslog.conf"
	[ -e '/etc/syslog.conf' ] && checkFile="/etc/syslog.conf"
	
	info=`cat $checkFile |grep "^authpriv.*\s*/var/log/secure"`
	[ -n "$info" ] && echo 1,"syslog系统日志审计启用" || echo 0,"syslog系统日志未启用"
}
pamAnyOneSuRootInfoCheck(){
	flag=0
	msg='INFO:'
	pam=`cat /etc/pam.d/su |grep -E "^\s*auth\s*required\s*pam_wheel.so\s*(use_uid|group=wheel)\s*"`
	[ -z "$pam" ] && msg=$msg"未启用SU pam模块;"
	# only=`cat /etc/login.defs | grep '^\s*SU_WHEEL_ONLY\s*yes'`
	# [ -z "$only" ] && msg=$msg"未配置SU_WHEEL_ONLY"
	[ "$msg" = "INFO:" ] && flag=1 && msg=$msg"su root配置正确"
	echo $flag,$msg
}
cronLogAccordInfoCheck(){	
	checkFile=""
	[ -e '/etc/rsyslog.conf' ] && checkFile="/etc/rsyslog.conf"
	[ -e '/etc/syslog.conf' ] && checkFile="/etc/syslog.conf"
	
	info=`cat $checkFile |grep "^\s*cron\.\*"`
	[ -n "$info" ] && echo 1,"cron日志记录设置正确" || echo 0,"cron日志记录设置错误"
}
messagesAttrCheck(){
	mod=`ls -l /var/log/messages | awk '{print $1}'`
	if [ ${mod:5:1} = - ]   # -
	then
			echo 1,"messages文件权限合规"
	else
			echo 0,"messages文件权限不合规"
	fi
}
srcIPRouteForbidenInfoCheck(){
	info=`sysctl -n net.ipv4.conf.all.accept_source_route`
	[ "$info" = "0" ] && echo 1,"禁止IP源路由正确" || echo 0,"禁止IP源路由错误"
}
dnsResoverOrderInfoCheck(){
	p1="^order.*bind"
	p2="^multi\s*on"
	p3="^nospoof\s*on"
	info1=`cat /etc/host.conf |egrep $p1 `
	info2=`cat /etc/host.conf |egrep $p2 `
	# info3=`cat /etc/host.conf |egrep $p3 `
	[ -n "$info1" ] && [ -n "$info2" ] && echo 1,"主机解析顺序配置正确" || echo 0,"主机解析顺序配置错误"
}
synCookieFloodInfoCheck(){
	info=`cat /proc/sys/net/ipv4/tcp_syncookies`
	[ "$info" = "1" ] && echo 1,"synCookie配置正确" || echo 0,"synCookie配置错误"
}
historyShellSaveInfoCheck(){
	histFile=`cat /etc/profile |grep -v "^\s*#" |grep "^\s*HISTFILESIZE" | sed -e 's/HISTFILESIZE=//'`
    histSelf=`cat /etc/profile |grep -v "^\s*#" |grep "^\s*HISTSIZE" |sed -e 's/HISTSIZE=//'`
    flag=0
	msg="INFO:"
    [ -z "$histFile" ] && msg=$msg'HISTFILESIZE 未设置;'
    [ -z "$histSelf" ] && msg=$msg'HISTSIZE 未设置;' 
    [ $histFile -gt 5 ] && msg=$msg"HISTFILESIZE 大于阈值5,当前值$histFile;" 
    [ $histSelf -gt 5 ] && msg=$msg"HISTSIZE 大于阈值5,当前值$histSelf;"
	[ $msg == "INFO:" ] && flag=1 && msg="HISTFILESIZE，HISTSIZE 设置正常;"
    echo $flag,$msg
}
aliasLSRMInfoCheck(){
	flag=0
	msg="INFO:"
	shell=""
	[ -e "/root/.cshrc" ] && shell="/root/.cshrc" 
	[ -e "/root/.bashrc" ] && shell="/root/.bashrc" 

	lsA="ls='ls -la'"
	rmA="rm='rm -i'"

	lsC=`cat "$shell" |grep "$lsA" | grep -v "^\s*#"`
	rmC=`cat "$shell" |grep "$rmA" | grep -v "^\s*#"`
	
	[ -z "$lsC" ] && msg=$msg'ls 未正确别名;' 
	[ -z "$rmC" ] && msg=$msg'rm 未正确别名'
	
	[ "$msg" = "INFO:" ] && flag=1 && msg=$msg"ls,rm别名正确'"
	echo $flag,$msg
}
localCountryOSInfoCheck(){
	[ $osType = 0 ] && echo 0,"非国产系统,`uname -a`" && return 
	[ $osType = 1 ] && echo 1,"麒麟OS" && return 
	[ $osType = 2 ] && echo 1,"凝思OS" && return 
}
permitRootLoginCheck(){
	rootLogin=`cat /etc/ssh/sshd_config |grep "^PermitRootLogin\s*no"`
	protocolSSH=`cat /etc/ssh/sshd_config |grep "^Protocol\s*2"`
	[ -z "$rootLogin" ] && echo 0,"未限制Root登录" && return
	[ -z "$protocolSSH" ] && echo 0,"SSH协议不是版本2" && return
	echo 1,no,2
}
unNeedServerPortInfoCheck(){
	unPorts="^25$|^110$|^80$|^8080$|^20$|^21$|^23$|^445$|^139$"
	ports=`netstat -antup |awk '{print $4}'|egrep -v '[a-zA-Z]' | sed -e 's/.*://' |uniq`
	info=`echo "$ports" | egrep "$unPorts"`
	[ -n "$info" ] && echo 0,"不必的端口开放检测到$info" && return 
	echo 1,"未有不必要端口开放"
}
whoLoginSystemInfoCheck(){
	whoLogin=`who | awk '{print $1}' |grep root |grep -v grep`
    [ -n "$whoLogin" ] && echo 0,"root用户登录,$whoLogin" && return
    echo 1,"无root用户登录"
}
cdrominterfaceCheck(){
	count=0
	[ ! -f "/proc/sys/dev/cdrom/info" ] && echo 1,"所有光驱设备已关闭" && return 
	line=`cat /proc/sys/dev/cdrom/info 2>/dev/null| grep "^drive name:[[:space:]]"`
	for item in $line
	do
			count=$[$count + 1]
	done

	cdrom_num=$[$count - 2]

	cdrom=`echo $line | sed 's/drive name:[[:space:]]//'`

	if [ "$cdrom_num" -eq 0 ]
	then
			echo 1,"所有光驱设备已关闭"
	else
			driver_name=`cat /proc/sys/dev/cdrom/info 2>/dev/null | grep "^drive name:[[:space:]]" |awk '{print $3}'`
			echo 0,"光驱设备"$driver_name"未关闭"
	fi
}
usbStorageKoInfoCheck(){
	ko=`ls /lib/modules/\`uname -r\`/kernel/drivers/usb/storage/ |grep "^usb-storage.ko$"`
	[ -z "$ko" ] && echo 1,"未加载usb设备功能" && return
	echo 0,'USB设备模块启用，不合规'
}
securityOSConfigInfoCheck(){
	if [ $osType = 1 ] ;then
		which rbapol > /dev/null 2>&1
		[ "$?" != "0" ] && echo 1,"麒麟系统未启用安全加固" && return
	  	rbapol > /dev/null 2>&1
		[ $? = 1 ] && echo 0,"麒麟系统已启用安全加固" || echo 0,"麒麟系统未启用安全加固"
	elif [ $osType = 2 ];then
		info=`lsmod |grep linx |grep lsm_linx`
		[ -z "$info" ] && echo 0,"凝思系统未安全加固" || echo 1,"凝思系统已安全加固"
		
	fi
}
auditLogInfoCheck(){
	if [ $osType = 1 ];then
		audit=`ps auxf|grep -w auditd |grep -v grep`
		[ -n "$audit" ] && echo 1,"日志审计已开启,`ls -l /var/log/audit/*`" && return
		echo 0,"日志审计功能未开启"
	elif [ $osType = 2];then
		audit=`ps auxf|grep ' auditd' |grep -v grep`
		[ -n "$audit" ] && echo 1,"日志审计已开启,`ls -l /var/log/*`" && return
		echo 0,"日志审计功能未开启"
	fi
}
schedMasterStationCertInfoCheck(){
	if [ -e "$D5000_HOME/data/security/pkcs12s" ];then
		info1=`ls $D5000_HOME/data/security/pkcs12s |grep SCADA.p12`
		[ -n "$info1" ] && echo 1,"主站有SCADA.12证书" || echo 0,"主站无SCADA.12证书"	
		return
	fi
	if [ -e "$D5000_HOME/data/security/certs" ];then
		info2=`ls $D5000_HOME/data/security/certs |grep SCADA.cer`
		[ -n "$info2" ] && echo 1,"PES主机有SCADA.cer证书" || echo 0,"PES无SCADA.cer"	
		return
	fi
	echo 0,"未检测到SCADA主机或PES主机"
}
controlFunctionSchedCertInfoCheck(){
	if [ -e "$D5000_HOME/data/security/pkcs12s" ];then
		info1=`ls $D5000_HOME/data/security/pkcs12s |egrep 'AGC.p12|AVC.p12'`
		[ -n "$info1" ] && echo 1,"AGC/AVC主机证书存在" || echo 0,"AGV/AVC主机无证书"	
		return
	fi
	if [ -e "$D5000_HOME/data/security/certs" ];then
		info2=`ls $D5000_HOME/data/security/certs |grep SCADA.cer`
		[ -n "$info2" ] && echo 1,"AGC/AVC主机有SCADA.cer" || echo 0,"AGC/AVC无SCADA.cer"	
		return
	fi
	echo 0,"未检测到AVG/AVC主机"
}
userResourceLimitedInfoCheck(){
	rss=`cat /etc/security/limits.conf|sed '/^\s*#/d'|sed '/^\s*$/d'|grep rss | awk '{print $4}'`
    stack=`cat /etc/security/limits.conf|sed '/^\s*#/d'|sed '/^\s*$/d'|grep stack | awk '{print $4}'`
    if [ -z "$rss" ] || [ -z "$stack" ] ;then
        echo 0,"rss,statck 未设置"
    else
		echo 1,"rss,stack 配置合规,$rss,$stack"
    fi
}
sshOrTelnetStatusCheck(){
	flag=0
	msg="INFO:"
	Tstatus="`chkconfig --list |grep -E 'telnet' | egrep 'on|启用' `"
    Sstatus="`chkconfig --list |grep -E 'sshd'   | egrep 'on|启用' `"
    [ -z "$Sstatus" ] && msg=$msg"SSH未开启" 
    [ -n "$Tstatus" ] && msg=$msg"SSH未开启" 

    [ "$msg" = "INFO:" ] && flag=1 && msg="远程运维服务配置正常"
    echo $flag,$msg
}
getSystemCoreVersionInfoCheck(){
	info=`uname -r`
	[ -n "$info" ] && echo 1,"系统内核版本:$info" || echo 0,"无法获取系统内核版本"
}
coreDumpStatusInfoCheck(){
	core_hard=`cat /etc/security/limits.conf | grep -v "[[:space:]]*#" | grep "[[:space:]]*[[:space:]]*hard[[:space:]]*core[[:space:]]*[[:digit:]]" | awk '{print $4}'`
	core_soft=`cat /etc/security/limits.conf | grep -v "[[:space:]]*#" | grep "[[:space:]]*[[:space:]]*soft[[:space:]]*core[[:space:]]*[[:digit:]]" | awk '{print $4}'`
	if [[ $core_hard -eq 0 ]] && [[ $core_soft -eq 0 ]]
	then 
		echo 1,'core dump 关闭'
	else
		echo 0,"core dump未关闭"
	fi
}
dangerFileFindCheck(){
	flag=0
	msg="INFO:"
	
	rhosts="`find /home -name '.rhosts' 2>/dev/null`"
	netrc="`find /home -name '.netrc' 2>/dev/null`"
	hostEuqiv="`find /etc -name 'hosts.equiv' 2>/dev/null`"

	[ -n "$rhosts" ] && msg=$msg"$rhosts;"
	[ -n "$netrc" ] &&  msg=$msg"$netrc"
	[ -n "$hostEuqiv" ] && msg="$msg$hostEuuiv"
	
	[ "$msg" = "INFO:" ] && flag=1 && msg="No Danger file"
	echo $flag,$msg
}
fileUmaskStatusCheck(){
	umaskInfo="`cat /etc/bashrc |grep "^umask"`"
	if [ -z "$umaskInfo" ];then
		echo 0,"未设置Umask"
	else
		lastUmask="`echo \"$umaskInfo\" |  sed -e 's/\s*umask\s*//g' | sed -e 's/\s//g'`"
		if [ "$lastUmask" = "027" ] ;then
			echo 1,027
		else
			echo 0,"$lastUmask"
		fi
	fi
}
srStorageKoInfoCheck(){
    [ -f "/lib/modules/`uname -r`/kernel/drivers/scsi/sr_mod.ko" ] && echo 0,"光驱服务未关闭" && return
    echo 1,'光驱服务关闭'
}
fileAuthStatusCheck(){
	passwd="`stat  /etc/passwd |grep 'Access: (' | awk '{print $2}'| cut -d '/' -f1 | sed -e 's/(//'`"
	shadow="`stat  /etc/shadow |grep 'Access: (' | awk '{print $2}'| cut -d '/' -f1 | sed -e 's/(//'`"
	egroup="`stat  /etc/group |grep 'Access: (' | awk '{print $2}'| cut -d '/' -f1 | sed -e 's/(//'`"
	
	passwdD="0644"
	shadowD="0600"
	egroupD="0644"
	
	flag=0
	msg="INFO:"
	check(){
		a=$1
		a1=`echo ${a:0:1}`;a2=`echo ${a:1:1}`;a3=`echo ${a:2:1}`;a4=`echo ${a:3:1}`;
		b=$2
		b1=`echo ${b:0:1}`;b2=`echo ${b:1:1}`;b3=`echo ${b:2:1}`;b4=`echo ${b:3:1}`;
		
		[ $a1 -le $b1 ] && [ $a2 -le $b2 ] && [ $a3 -le $b3 ] && [ $a4 -le $b4 ] && echo 1 || echo 0
		
	}
	
	[ `check $passwd $passwdD` = 1 ] || msg=$msg"passwd:$passwd;" 
	[ `check $shadow $shadowD` = 1 ] || msg=$msg"shadow:$shadow;" 
	[ `check $egroup $egroupD` = 1 ] || msg=$msg"egroup:$egroup;"
	
	[ "$msg" = "INFO:" ] && flag=1 && msg=$msg"All Auth ok"

	echo $flag,$msg
}
passAliveLifeCheck(){
	pMax=`cat /etc/login.defs |grep "^PASS_MAX_DAYS"  |awk '{print $2}'`
	pMin=`cat /etc/login.defs |grep "^PASS_MIN_DAYS"  |awk '{print $2}'`
	pWar=`cat /etc/login.defs |grep "^PASS_WARN_AGE"  |awk '{print $2}'`
	flag=0
	msg="INFO:"
	[ $pMax -le 90 ] || msg=$msg"max_days:$pMax;" 
	# [ $pMin = 10 ] ||   msg=$msg"min_days:$pMin;" 
	[ $pWar = 7 ] ||    msg=$msg"warn_age:$pWar" 
	[ "$msg" = "INFO:" ] && flag=1 && msg=$msg"All is ok:$pMax,$pMin,$pWar"
	echo $flag,$msg
}
uidUserOnlyOneInfoCheck(){
    userID=`cat /etc/passwd | awk -F: '{print $3}' | sed -n '$!N;/\(.*\)\n\1$/{P;ba};x;/\(.*\)\n\1$/P;x;:a;h;D' |  uniq`
    #userID=`cat a | awk -F: '{print $1}' | sed -n '$!N;/\(.*\)\n\1$/{P;ba};x;/\(.*\)\n\1$/P;x;:a;h;D' | uniq`
    [ -z "$userID" ] && echo 1,'无重复UID用户' && return
    users=''
    for u in `echo $userID`
    do
        tmp="`cat /etc/passwd | awk -F: '{print $1 , $3}' | grep $u`"
        #tmp="`cat a | awk -F: '{print $1 , $2}' | egrep "^$u "`"
        [ -n "$tmp" ] && users="$tmp;$users"
    done
    echo 0,'存在重复Uid用户:'$users
}
baselineFun52Check(){
    userID=`cat /etc/passwd | awk -F: '{print $3}' | sed -n '$!N;/\(.*\)\n\1$/{P;ba};x;/\(.*\)\n\1$/P;x;:a;h;D' |  uniq`
    #userID=`cat a | awk -F: '{print $1}' | sed -n '$!N;/\(.*\)\n\1$/{P;ba};x;/\(.*\)\n\1$/P;x;:a;h;D' | uniq`
    [ -z "$userID" ] && echo 1,'无重复UID用户' && return
    users=''
    for u in `echo $userID`
    do
        tmp="`cat /etc/passwd | awk -F: '{print $1 , $3}' | grep $u`"
        #tmp="`cat a | awk -F: '{print $1 , $2}' | egrep "^$u "`"
        [ -n "$tmp" ] && users="$tmp;$users"
    done
    echo 0,'存在重复Uid用户:'$users
}
baselineFun53Check(){
	userID=`cat /etc/passwd | awk -F: '{print $3}' | sed -n '$!N;/\(.*\)\n\1$/{P;ba};x;/\(.*\)\n\1$/P;x;:a;h;D' |  uniq`
    #userID=`cat a | awk -F: '{print $1}' | sed -n '$!N;/\(.*\)\n\1$/{P;ba};x;/\(.*\)\n\1$/P;x;:a;h;D' | uniq`
    [ -z "$userID" ] && echo 1,'无重复UID用户' && return
    users=''
    for u in `echo $userID`
    do
        tmp="`cat /etc/passwd | awk -F: '{print $1 , $3}' | grep $u`"
        #tmp="`cat a | awk -F: '{print $1 , $2}' | egrep "^$u "`"
        [ -n "$tmp" ] && users="$tmp;$users"
    done
    echo 0,'存在重复Uid用户:'$users
}
baselineFun54Check(){
	userID=`cat /etc/passwd | awk -F: '{print $3}' | sed -n '$!N;/\(.*\)\n\1$/{P;ba};x;/\(.*\)\n\1$/P;x;:a;h;D' |  uniq`
    #userID=`cat a | awk -F: '{print $1}' | sed -n '$!N;/\(.*\)\n\1$/{P;ba};x;/\(.*\)\n\1$/P;x;:a;h;D' | uniq`
    [ -z "$userID" ] && echo 1,'无重复UID用户' && return
    users=''
    for u in `echo $userID`
    do
        tmp="`cat /etc/passwd | awk -F: '{print $1 , $3}' | grep $u`"
        #tmp="`cat a | awk -F: '{print $1 , $2}' | egrep "^$u "`"
        [ -n "$tmp" ] && users="$tmp;$users"
    done
    echo 0,'存在重复Uid用户:'$users
}
baselineFun55Check(){
	userID=`cat /etc/passwd | awk -F: '{print $3}' | sed -n '$!N;/\(.*\)\n\1$/{P;ba};x;/\(.*\)\n\1$/P;x;:a;h;D' |  uniq`
    #userID=`cat a | awk -F: '{print $1}' | sed -n '$!N;/\(.*\)\n\1$/{P;ba};x;/\(.*\)\n\1$/P;x;:a;h;D' | uniq`
    [ -z "$userID" ] && echo 1,'无重复UID用户' && return
    users=''
    for u in `echo $userID`
    do
        tmp="`cat /etc/passwd | awk -F: '{print $1 , $3}' | grep $u`"
        #tmp="`cat a | awk -F: '{print $1 , $2}' | egrep "^$u "`"
        [ -n "$tmp" ] && users="$tmp;$users"
    done
    echo 0,'存在重复Uid用户:'$users
}
baselineFun56Check(){
	userID=`cat /etc/passwd | awk -F: '{print $3}' | sed -n '$!N;/\(.*\)\n\1$/{P;ba};x;/\(.*\)\n\1$/P;x;:a;h;D' |  uniq`
    #userID=`cat a | awk -F: '{print $1}' | sed -n '$!N;/\(.*\)\n\1$/{P;ba};x;/\(.*\)\n\1$/P;x;:a;h;D' | uniq`
    [ -z "$userID" ] && echo 1,'无重复UID用户' && return
    users=''
    for u in `echo $userID`
    do
        tmp="`cat /etc/passwd | awk -F: '{print $1 , $3}' | grep $u`"
        #tmp="`cat a | awk -F: '{print $1 , $2}' | egrep "^$u "`"
        [ -n "$tmp" ] && users="$tmp;$users"
    done
    echo 0,'存在重复Uid用户:'$users
}
baselineFun57Check(){
	userID=`cat /etc/passwd | awk -F: '{print $3}' | sed -n '$!N;/\(.*\)\n\1$/{P;ba};x;/\(.*\)\n\1$/P;x;:a;h;D' |  uniq`
    #userID=`cat a | awk -F: '{print $1}' | sed -n '$!N;/\(.*\)\n\1$/{P;ba};x;/\(.*\)\n\1$/P;x;:a;h;D' | uniq`
    [ -z "$userID" ] && echo 1,'无重复UID用户' && return
    users=''
    for u in `echo $userID`
    do
        tmp="`cat /etc/passwd | awk -F: '{print $1 , $3}' | grep $u`"
        #tmp="`cat a | awk -F: '{print $1 , $2}' | egrep "^$u "`"
        [ -n "$tmp" ] && users="$tmp;$users"
    done
    echo 0,'存在重复Uid用户:'$users
}

$1